﻿Imports Infragistics.Web.UI.GridControls
Imports Infragistics.Web.UI
Imports System.Runtime.Serialization.Json
Imports System.Runtime.Serialization
Imports System.IO

Public Class WebForm1
    Inherits System.Web.UI.Page

    Private Const DS_KEY As String = "TEST_DS_KEY"

    Private Class ButtonTemplate
        Implements ITemplate

        Private sCmd As String
        Private sText As String

        Public Sub New(sText As String, sCmd As String)
            Me.sCmd = sCmd
            Me.sText = sText
        End Sub

        Public Sub InstantiateIn(container As System.Web.UI.Control) Implements System.Web.UI.ITemplate.InstantiateIn
            Dim btn As New Button
            Dim tc As TemplateContainer = container

            btn.ID = "cellButton" & sCmd
            btn.Text = sText
            btn.CommandName = sCmd
            tc.Controls.Add(btn)
        End Sub
    End Class

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        If IsPostBack Then
            If Session(DS_KEY) IsNot Nothing Then
                WebHierarchicalDataGrid1.DataSource = Session(DS_KEY)
                WebHierarchicalDataGrid1.DataBind()
            End If
        Else
            WebHierarchicalDataGrid1.Columns.Add(New BoundDataField() With {.Key = "col1", .DataFieldName = "col1", .Width = 100})
            WebHierarchicalDataGrid1.Columns.Add(New TemplateDataField() With {.Key = "button1", .Width = 100, .ItemTemplate = New ButtonTemplate("haha", "cmdA")})
            WebHierarchicalDataGrid1.Columns.Add(New TemplateDataField() With {.Key = "button2", .Width = 100, .ItemTemplate = New ButtonTemplate("hehe", "cmdB")})
        End If
    End Sub

    Public Sub FillGrid()
        WebHierarchicalDataGrid1.Rows.Clear()
        WebHierarchicalDataGrid1.DataSource = CreateMasterDS()
        WebHierarchicalDataGrid1.DataBind()
        UpdatePanel1.Update()
    End Sub

    Private Function CreateMasterDS() As DataSet
        Dim ds As New DataSet

        ds.Tables.Add("table1")
        ds.Tables.Add("table2")

        ds.Tables(0).Columns.Add("id", GetType(Integer))
        ds.Tables(0).Columns.Add("col1", GetType(String))
        ds.Tables(0).Columns.Add("col2", GetType(String))
        ds.Tables(1).Columns.Add("id", GetType(Integer))
        ds.Tables(0).PrimaryKey = New DataColumn() {ds.Tables(0).Columns("id")}
        ds.Tables(1).PrimaryKey = New DataColumn() {ds.Tables(1).Columns("id")}

        ds.Relations.Add("fk1", ds.Tables(0).Columns("id"), ds.Tables(1).Columns("id"))

        ds.Tables(0).Rows.Add(1, "bla1", "blub1")
        ds.Tables(0).Rows.Add(2, "bla2", "blub2")
        ds.Tables(0).Rows.Add(3, "bla3", "blub3")
        ds.Tables(0).Rows.Add(4, "bla4", "blub4")

        Return ds
    End Function

    Private Function CreateDetailDS(iRow As Integer) As DataTable
        Dim oData As New DataTable()
        oData.Columns.Add("id", GetType(Integer))
        oData.Columns.Add("col1", GetType(String))
        oData.Columns.Add("col2", GetType(Boolean))
        oData.PrimaryKey = New DataColumn() {oData.Columns("id")}


        oData.Rows.Add(1, "ble1_" & iRow, True)
        oData.Rows.Add(2, "ble2_" & iRow, False)

        Return oData
    End Function

    Private Sub WebHierarchicalDataGrid1_RowIslandDataBinding(sender As Object, e As Infragistics.Web.UI.GridControls.RowIslandEventArgs) Handles WebHierarchicalDataGrid1.RowIslandDataBinding
        If e.RowIsland.DataMember = WebHierarchicalDataGrid1.DataMember Then
            Dim itemplate As TemplateDataField
            itemplate = DirectCast(WebHierarchicalDataGrid1.Columns.FromKey("button1"), TemplateDataField)
            itemplate.ItemTemplate = New ButtonTemplate("haha", "cmdA")
            itemplate = DirectCast(WebHierarchicalDataGrid1.Columns.FromKey("button2"), TemplateDataField)
            itemplate.ItemTemplate = New ButtonTemplate("hehe", "cmdB")
        End If
    End Sub

    Protected Sub WebHierarchicalDataGrid1_RowIslandsPopulating(sender As Object, e As Infragistics.Web.UI.GridControls.ContainerRowCancelEventArgs) Handles WebHierarchicalDataGrid1.RowIslandsPopulating
        e.Cancel = True

        Dim oChildGrid As New ContainerGrid()
        oChildGrid.Band = WebHierarchicalDataGrid1.Bands(0)
        oChildGrid.AutoGenerateColumns = False
        e.Row.RowIslands.Add(oChildGrid)

        oChildGrid.DataSource = CreateDetailDS(e.Row.Index)
        oChildGrid.DataBind()
    End Sub

    Protected Sub WebHierarchicalDataGrid1_PreRender(sender As Object, e As EventArgs) Handles WebHierarchicalDataGrid1.PreRender
        If WebHierarchicalDataGrid1.DataSource IsNot Nothing Then
            For Each oRow As ContainerGridRecord In WebHierarchicalDataGrid1.GridView.Rows
                oRow.IsEmptyParent = True
            Next
            Session(DS_KEY) = WebHierarchicalDataGrid1.DataSource
        End If
    End Sub

    Protected Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        FillGrid()
    End Sub

End Class